/*
 * Copyright (C) 2022 Uniontech Software Technology Co., Ltd.
 *
 * Author:     liuyangming<liuyangming@uniontech.com>
 *
 * Maintainer: zhengyouge<zhengyouge@uniontech.com>
 *             yanghao<yanghao@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef TAGFILEWATCHER_H
#define TAGFILEWATCHER_H

#include "dfmplugin_tag_global.h"
#include "dfm-base/interfaces/abstractfilewatcher.h"

namespace dfmplugin_tag {

class TagFileWatcherPrivate;
class TagFileWatcher : public DFMBASE_NAMESPACE::AbstractFileWatcher
{
    Q_OBJECT
public:
    explicit TagFileWatcher() = delete;
    explicit TagFileWatcher(const QUrl &url, QObject *parent = nullptr);
    ~TagFileWatcher() override;

    virtual void setEnabledSubfileWatcher(const QUrl &subfileUrl, bool enabled = true) override;

public slots:
    void onTagRemoved(const QString &tagName);
    void onFilesTagged(const QMap<QString, QStringList> &fileAndTags);
    void onFilesUntagged(const QMap<QString, QStringList> &fileAndTags);

private:
    void addWatcher(const QUrl &url);
    void removeWatcher(const QUrl &url);

    void onFileDeleted(const QUrl &url);
    void onFileAttributeChanged(const QUrl &url);

    TagFileWatcherPrivate *dptr = nullptr;
};

}

#endif   // TAGFILEWATCHER_H
