/*
 * Copyright (C) 2020 ~ 2021 Uniontech Software Technology Co., Ltd.
 *
 * Author:     zhangsheng<zhangsheng@uniontech.com>
 *
 * Maintainer: max-lv<lvwujun@uniontech.com>
 *             lanxuesong<lanxuesong@uniontech.com>
 *             xushitong<xushitong@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef INTERFACES_H
#define INTERFACES_H

#include <dfm-framework/lifecycle/plugin.h>

#include <mutex>

class QDBusConnection;
class DeviceManagerDBus;
class OperationsStackManagerDbus;
class VaultManagerDBus;
class FileManager1DBus;
class DBusRegister : public dpf::Plugin
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.deepin.plugin.desktop" FILE "dbusregister.json")

public:
    virtual void initialize() override;
    virtual bool start() override;

private Q_SLOTS:
    void onWindowShowed();

private:
    static std::once_flag &onceFlag();

    void initServiceDBusInterfaces(QDBusConnection *connection);
    void initFreedesktopDBusInterfaces(QDBusConnection *connection);

    void initDeviceDBus(QDBusConnection *connection);
    void initOperationsDBus(QDBusConnection *connection);
    void initVaultDBus(QDBusConnection *connection);
    void initFileManager1DBus(QDBusConnection *connection);

private:
    QScopedPointer<DeviceManagerDBus> deviceManager;
    QScopedPointer<OperationsStackManagerDbus> operationsStackManager;
    QScopedPointer<VaultManagerDBus> vaultManager;
    QScopedPointer<FileManager1DBus> filemanager1;
};

#endif   // INTERFACES_H
