/*
 * Copyright (C) 2021 Uniontech Software Technology Co., Ltd.
 *
 * Author:     xushitong<xushitong@uniontech.com>
 *
 * Maintainer: max-lv<lvwujun@uniontech.com>
 *             lanxuesong<lanxuesong@uniontech.com>
 *             zhangsheng<zhangsheng@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef DFMPLUGIN_COMPUTER_GLOBAL_H
#define DFMPLUGIN_COMPUTER_GLOBAL_H

#define DPCOMPUTER_NAMESPACE dfmplugin_computer

#define DPCOMPUTER_BEGIN_NAMESPACE namespace DPCOMPUTER_NAMESPACE {
#define DPCOMPUTER_END_NAMESPACE }
#define DPCOMPUTER_USE_NAMESPACE using namespace DPCOMPUTER_NAMESPACE;

#include <QIcon>
#include <QUrl>

DPCOMPUTER_BEGIN_NAMESPACE

struct DeviceInfo
{
    QIcon icon;
    QUrl deviceUrl;
    QUrl mountPoint;
    QString deviceName;
    QString deviceType;
    QString fileSystem;
    qint64 totalCapacity;
    qint64 availableSpace;
};

DPCOMPUTER_END_NAMESPACE
#endif   // DFMPLUGIN_COMPUTER_GLOBAL_H
