/*
 * Copyright (C) 2021 Uniontech Software Technology Co., Ltd.
 *
 * Author:     zhangsheng<zhangsheng@uniontech.com>
 *
 * Maintainer: max-lv<lvwujun@uniontech.com>
 *             lanxuesong<lanxuesong@uniontech.com>
 *             xushitong<xushitong@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef DETAILSPACE_H
#define DETAILSPACE_H

#include "dfmplugin_detailspace_global.h"

#include <dfm-framework/dpf.h>

namespace dfmplugin_detailspace {

class DetailSpace : public dpf::Plugin
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.deepin.plugin.filemanager" FILE "detailspace.json")

    DPF_EVENT_NAMESPACE(DPDETAILSPACE_NAMESPACE)

    // slot events
    DPF_EVENT_REG_SLOT(slot_DetailView_Show)
    DPF_EVENT_REG_SLOT(slot_ViewExtension_Register)
    DPF_EVENT_REG_SLOT(slot_BasicViewExtension_Register)
    DPF_EVENT_REG_SLOT(slot_BasicViewExtension_Root_Register)
    DPF_EVENT_REG_SLOT(slot_BasicFiledFilter_Add)
    DPF_EVENT_REG_SLOT(slot_BasicFiledFilter_Root_Add)

    // hook evetns
    DPF_EVENT_REG_HOOK(hook_Icon_Fetch)

public:
    virtual void initialize() override;
    virtual bool start() override;

private slots:
    void onWindowClosed(quint64 windId);
};

}

#endif   // DETAILSPACE_H
